//+------------------------------------------------------------------+ 
//|                                        _TRO_RANGE_test.mq4       | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 


//---- indicator settings 
#property  indicator_separate_window 
#property  indicator_buffers 2 
#property  indicator_color1  Red 
#property  indicator_color2  Green 

#property  indicator_minimum 0

//---- indicator parameters  
extern int   Threshold = 10; 
extern color CurrentBarColor = White; 
extern color ThresholdColor  = Aqua; 


//---- indicator buffers 
double     RANGEBuffer[]; 
double     RANGEBuffer1[]; 


bool OkToInit  ;


double HighVal,LowVal, pHighVal,pLowVal, xRange; 
   
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 

//---- drawing settings 
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2); 
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2); 
//---- indicator buffers mapping 
   SetIndexBuffer(0,RANGEBuffer); 
   SetIndexBuffer(1,RANGEBuffer1);  
//---- name for DataWindow and indicator subwindow label 
   IndicatorShortName("RANGE"); 
   SetIndexLabel(0,"RANGE"); 
   SetIndexLabel(1,"RANGE"); 

OkToInit = true ;  // turn switch on to load all buffers

//---- initialization done 
   return(0); 
  } 
  

//+------------------------------------------------------------------+   
  
int deinit() 
{ 

}  
//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   datetime pTime;
  
   int limit, pBars; 
   int counted_bars=IndicatorCounted(); 
   
   
  if(counted_bars>0) counted_bars--; 
  limit=Bars-counted_bars; 
  
  if( OkToInit )
    { OkToInit = false ;  
      
       for(int i=limit; i>=0; i--)  
       { 
       // CALCULATE AND LOAD BUFFERS  - ONLY DO IT ONCE!!
       
       DoWork(i) ; 
      
       } // for
    } else {     
      

       if( pBars != Bars ) //  DO THIS WHEN BAR CHANGES - ONLY DO IT ONCE!!
       {
       for(i=limit; i>=0; i--) // SHIFT BUFFER VALUES DOWN 1  SO [X+1] = [X]  
       { RANGEBuffer[i+1] = RANGEBuffer[i] ;
         RANGEBuffer1[i+1]= RANGEBuffer1[i] ;
         pBars            = Bars ;  
       } // for
       } // if
  

       // CALCULATE AND LOAD CURRENT BUFFERS - [0]  
  
       DoWork(0) ; 

    } // if     

   return(0); 
  } 
  

//+------------------------------------------------------------------+ 

void DoWork ( int w )
{

       HighVal  = iHigh(NULL,0,w);        
       LowVal   = iLow(NULL,0,w); 
       xRange   = (HighVal - LowVal) / Point ;
     
       if (xRange >= Threshold) { RANGEBuffer1[w] = xRange ; } 
       else { RANGEBuffer[w] = xRange ; }  

}